unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    StartButton: TButton;
    StopButton: TButton;
    LogMemo: TMemo;
    TestTime: TTimer;
    Label1: TLabel;
    ByteLabel0: TLabel;
    ByteLabel1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ByteLabel2: TLabel;
    ByteLabel3: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ByteLabel4: TLabel;
    ByteLabel5: TLabel;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure TestTimeTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  AIOWDM;

function IntToBin(I, MinBits: LongWord): String;
var
  DoneBits: LongWord;

begin
  Result := '';
  DoneBits := 0;
  repeat
    Result := Char(Byte('0') + (I and 1)) + Result;
    I := I shr 1;
    Inc(DoneBits);
  until (I = 0) and (DoneBits >= MinBits);
end;

var
  CardNum: Integer;
  TestClock: Integer;

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
  DeviceID: LongWord;

begin
  CardNum := -1;

  if (InPortB($61) = $AA55) then begin
    LogMemo.Lines.Add('AIOWDM/ACCESNT.SYS not detected! This test won''t work.');
    LogMemo.Lines.Add('');
  end;

  for I := 0 to GetNumCards-1 do begin
    if QueryCardInfo(I, @DeviceID, nil, nil, nil) = 0 then Continue;
    if DeviceID <> $0520 then Continue;

    CardNum := I;
    Break;
  end;

  if CardNum < 0 then begin
    LogMemo.Lines.Add('No PCI-IDO-48 found!');
  end
  else begin
    LogMemo.Lines.Add('PCI-IDO-48 found. Click Start to start testing.');
    StartButton.Enabled := True;
  end;
end;

procedure TForm1.StartButtonClick(Sender: TObject);
begin
  StartButton.Enabled := False;

  TestTime.Enabled := True;

  StopButton.Enabled := True;
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
  StopButton.Enabled := False;

  TestTime.Enabled := False;

  StartButton.Enabled := True;
end;

procedure TForm1.TestTimeTimer(Sender: TObject);
var
  I: Integer;

begin
  if (TestClock mod 10) = 0 then begin
    I := (TestClock div 10) mod 8;
    RelOutPortB(CardNum, 0, 1 shl I);
    I := (I + 1) mod 8;
    RelOutPortB(CardNum, 1, 1 shl I);
    I := (I + 1) mod 8;
    RelOutPortB(CardNum, 2, 1 shl I);
    I := (I + 1) mod 8;
    RelOutPortB(CardNum, 4, 1 shl I);
    I := (I + 1) mod 8;
    RelOutPortB(CardNum, 5, 1 shl I);
    I := (I + 1) mod 8;
    RelOutPortB(CardNum, 6, 1 shl I);
  end;

  ByteLabel0.Caption := IntToBin(RelInPortB(CardNum, 0), 8);
  ByteLabel1.Caption := IntToBin(RelInPortB(CardNum, 1), 8);
  ByteLabel2.Caption := IntToBin(RelInPortB(CardNum, 2), 8);
  ByteLabel3.Caption := IntToBin(RelInPortB(CardNum, 4), 8);
  ByteLabel4.Caption := IntToBin(RelInPortB(CardNum, 5), 8);
  ByteLabel5.Caption := IntToBin(RelInPortB(CardNum, 6), 8);

  Inc(TestClock);
end;

end.
